// Copyright (C) 2005-2007 Stefan Bauer <yoltia-maintain@freenet.de>

// This file is part of Yoltia.
//
// Yoltia is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License Version 2
// as published by the Free Software Foundation.
//    
// Yoltia is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Yoltia; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

#ifndef SLISTMAN_HPP
#define SLISTMAN_HPP

#include <qdir.h>
#include <qstringlist.h>

enum SListMode {one = 0 , own = 1 , directory = 2};
class SListMan {
  public :
    SListMan();
    void setOwnMode(QStringList ownList);
    void setOneMode();
    void setDirectoryMode(QString dirFile);
    QString next();
    QString prev();
    QString first();
    QString last();
    QString act();
    QString atActPos();
    QString browseInfo();
    QString goTo(const int gotoPos);
    int currentPos();
    int count();
    bool isBrowseable();
    bool isOneMode();
    bool isDirMode();
    bool isOwnMode();
    void convertToOwn();
    QStringList filelist();
  private :
    void refresh();
    QStringList list;
    SListMode mode;
    QDir dir;
    int pos;
    QString file;
};

inline QString SListMan::act() {
  return file;
}

inline bool SListMan::isOneMode() {
  return mode == one;
}

inline bool SListMan::isDirMode() {
  return mode == directory;
}

inline bool SListMan::isOwnMode() {
  return mode == own;
}

inline int SListMan::currentPos() {
  return pos;
}

inline int SListMan::count() {
  return list.count();
}

#endif
